#include <stdio.h>
#include <stdlib.h>
#include "circular_buf.h"


void initialize_buffer(struct circular_buffer* cb) {
	cb->buf_head = 0;
	cb->buf_tail = 0;
}
// ,    
int buffer_empty(const struct circular_buffer* cb) {
	return cb->buf_head == cb->buf_tail;
}
// ,    
int buffer_full(const struct circular_buffer* cb) {
	return (cb->buf_tail + 1) % BUFFER_SIZE == cb->buf_head;//  ,          false,    true
}
//    
void write_buffer(struct circular_buffer* cb, int value) {
	if (buffer_full(cb)) { //     
		return;
	}
	cb->buffer[cb->buf_tail] = value;//  value    buffer  
	cb->buf_tail = (cb->buf_tail + 1) % BUFFER_SIZE;// cb->buf_tail,         
}
//    
int read_buffer(struct circular_buffer* cb) {
	if (buffer_empty(cb)) { //   
		return -1;// -1     
	}
	int value = cb->buffer[cb->buf_head]; //      
	cb->buf_head = (cb->buf_head + 1) % BUFFER_SIZE; //   +1
	return value;
}


